package com.miaxis.common.config;


import lombok.Data;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

@Data
@Component
public class ShiShenConfig {

    //天干地支颜色
    private Map<String, String> ganZhiColor = new TreeMap<String, String>();
    //天干地支五行
    private Map<String, String> ganZhiFive = new TreeMap<String, String>();
    //正印
    private Map<String, String> zhengYin = new TreeMap<String, String>();
    //食神
    private Map<String, String> shiShen = new TreeMap<String, String>();
    //正官
    private Map<String, String> zhengGuan = new TreeMap<String, String>();
    //正财
    private Map<String, String> zhengCai = new TreeMap<String, String>();
    //七杀
    private Map<String, String> qiSha = new TreeMap<String, String>();
    //偏印
    private Map<String, String> pianYin = new TreeMap<String, String>();
    //伤官
    private Map<String, String> shangGuan = new TreeMap<String, String>();
    //劫财
    private Map<String, String> jieCai = new TreeMap<String, String>();
    //比肩
    private Map<String, String> biJian = new TreeMap<String, String>();
    //偏财
    private Map<String, String> pianCai = new TreeMap<String, String>();


    //藏干 本气
    private Map<String, String> benQi = new TreeMap<String, String>();
    //藏干 中气
    private Map<String, String> zhongQi = new TreeMap<String, String>();
    //藏干 余气
    private Map<String, String> yuQi = new TreeMap<String, String>();

    //空亡
    private Map<String, String> kongWang = new TreeMap<String, String>();

    //纳音
    private Map<String, String> naYin = new TreeMap<String, String>();


    //喜用
    private Map<String, List> xiYong = new TreeMap<String, List>();

    //喜用的数字
    private Map<String, List> xiNumber = new TreeMap<String, List>();

    //数字文案
    private Map<String, String> numberWenAn = new TreeMap<String, String>();

    //燥湿平衡
    private Map<String, String> zaoShi = new TreeMap<String, String>();

    @PostConstruct
    public void init() {

        //天干地支颜色
        ganZhiColor.put("甲","绿");
        ganZhiColor.put("乙","绿");
        ganZhiColor.put("丙","红");
        ganZhiColor.put("丁","红");
        ganZhiColor.put("戊","棕");
        ganZhiColor.put("己","棕");
        ganZhiColor.put("庚","橙");
        ganZhiColor.put("辛","橙");
        ganZhiColor.put("壬","蓝");
        ganZhiColor.put("癸","蓝");

        ganZhiColor.put("子","蓝");
        ganZhiColor.put("丑","棕");
        ganZhiColor.put("寅","绿");
        ganZhiColor.put("卯","绿");
        ganZhiColor.put("辰","棕");
        ganZhiColor.put("巳","红");
        ganZhiColor.put("午","红");
        ganZhiColor.put("未","棕");
        ganZhiColor.put("申","橙");
        ganZhiColor.put("酉","橙");
        ganZhiColor.put("戌","棕");
        ganZhiColor.put("亥","蓝");

        //天干地支五行
        ganZhiFive.put("甲","木");
        ganZhiFive.put("乙","木");
        ganZhiFive.put("丙","火");
        ganZhiFive.put("丁","火");
        ganZhiFive.put("戊","土");
        ganZhiFive.put("己","土");
        ganZhiFive.put("庚","金");
        ganZhiFive.put("辛","金");
        ganZhiFive.put("壬","水");
        ganZhiFive.put("癸","水");

        ganZhiFive.put("子","水");
        ganZhiFive.put("丑","土");
        ganZhiFive.put("寅","木");
        ganZhiFive.put("卯","木");
        ganZhiFive.put("辰","土");
        ganZhiFive.put("巳","火");
        ganZhiFive.put("午","火");
        ganZhiFive.put("未","土");
        ganZhiFive.put("申","金");
        ganZhiFive.put("酉","金");
        ganZhiFive.put("戌","土");
        ganZhiFive.put("亥","水");

        //正印
        zhengYin.put("癸", "甲");
        zhengYin.put("壬", "乙");
        zhengYin.put("乙", "丙");
        zhengYin.put("甲", "丁");
        zhengYin.put("丁", "戊");
        zhengYin.put("丙", "己");
        zhengYin.put("己", "庚");
        zhengYin.put("戊", "辛");
        zhengYin.put("辛", "壬");
        zhengYin.put("庚", "癸");

        //食神
        shiShen.put("丙", "甲");
        shiShen.put("丁", "乙");
        shiShen.put("戊", "丙");
        shiShen.put("己", "丁");
        shiShen.put("庚", "戊");
        shiShen.put("辛", "己");
        shiShen.put("壬", "庚");
        shiShen.put("癸", "辛");
        shiShen.put("甲", "壬");
        shiShen.put("乙", "癸");

        //正官
        zhengGuan.put("辛", "甲");
        zhengGuan.put("庚", "乙");
        zhengGuan.put("癸", "丙");
        zhengGuan.put("壬", "丁");
        zhengGuan.put("乙", "戊");
        zhengGuan.put("甲", "己");
        zhengGuan.put("丁", "庚");
        zhengGuan.put("丙", "辛");
        zhengGuan.put("己", "壬");
        zhengGuan.put("戊", "癸");

        //正财
        zhengCai.put("己", "甲");
        zhengCai.put("戊", "乙");
        zhengCai.put("辛", "丙");
        zhengCai.put("庚", "丁");
        zhengCai.put("癸", "戊");
        zhengCai.put("壬", "己");
        zhengCai.put("乙", "庚");
        zhengCai.put("甲", "辛");
        zhengCai.put("丁", "壬");
        zhengCai.put("丙", "癸");


        //七杀
        qiSha.put("庚", "甲");
        qiSha.put("辛", "乙");
        qiSha.put("壬", "丙");
        qiSha.put("癸", "丁");
        qiSha.put("甲", "戊");
        qiSha.put("乙", "己");
        qiSha.put("丙", "庚");
        qiSha.put("丁", "辛");
        qiSha.put("戊", "壬");
        qiSha.put("己", "癸");

        //偏印
        pianYin.put("壬", "甲");
        pianYin.put("癸", "乙");
        pianYin.put("甲", "丙");
        pianYin.put("乙", "丁");
        pianYin.put("丙", "戊");
        pianYin.put("丁", "己");
        pianYin.put("戊", "庚");
        pianYin.put("己", "辛");
        pianYin.put("庚", "壬");
        pianYin.put("辛", "癸");

        //伤官
        shangGuan.put("丁", "甲");
        shangGuan.put("丙", "乙");
        shangGuan.put("己", "丙");
        shangGuan.put("戊", "丁");
        shangGuan.put("辛", "戊");
        shangGuan.put("庚", "己");
        shangGuan.put("癸", "庚");
        shangGuan.put("壬", "辛");
        shangGuan.put("乙", "壬");
        shangGuan.put("甲", "癸");

        //劫财
        jieCai.put("乙", "甲");
        jieCai.put("甲", "乙");
        jieCai.put("丁", "丙");
        jieCai.put("丙", "丁");
        jieCai.put("己", "戊");
        jieCai.put("戊", "己");
        jieCai.put("辛", "庚");
        jieCai.put("庚", "辛");
        jieCai.put("癸", "壬");
        jieCai.put("壬", "癸");

        //比肩
        biJian.put("甲", "甲");
        biJian.put("乙", "乙");
        biJian.put("丙", "丙");
        biJian.put("丁", "丁");
        biJian.put("戊", "戊");
        biJian.put("己", "己");
        biJian.put("庚", "庚");
        biJian.put("辛", "辛");
        biJian.put("壬", "壬");
        biJian.put("癸", "癸");


        //偏财
        pianCai.put("戊", "甲");
        pianCai.put("己", "乙");
        pianCai.put("庚", "丙");
        pianCai.put("辛", "丁");
        pianCai.put("壬", "戊");
        pianCai.put("癸", "己");
        pianCai.put("甲", "庚");
        pianCai.put("乙", "辛");
        pianCai.put("丙", "壬");
        pianCai.put("丁", "癸");


        //本气
        benQi.put("子", "癸");
        benQi.put("丑", "己");
        benQi.put("寅", "甲");
        benQi.put("卯", "乙");
        benQi.put("辰", "戊");
        benQi.put("巳", "丙");
        benQi.put("午", "丁");
        benQi.put("未", "己");
        benQi.put("申", "庚");
        benQi.put("酉", "辛");
        benQi.put("戌", "戊");
        benQi.put("亥", "壬");

        //中气
        zhongQi.put("丑", "辛");
        zhongQi.put("寅", "丙");
        zhongQi.put("辰", "乙");
        zhongQi.put("巳", "戊");
        zhongQi.put("午", "己");
        zhongQi.put("未", "丁");
        zhongQi.put("申", "壬");
        zhongQi.put("戌", "辛");
        zhongQi.put("亥", "甲");

        //余气
        yuQi.put("丑", "癸");
        yuQi.put("寅", "戊");
        yuQi.put("辰", "癸");
        yuQi.put("巳", "庚");
        yuQi.put("未", "乙");
        yuQi.put("申", "戊");
        yuQi.put("戌", "丁");


        //空亡
        //1甲子旬
        kongWang.put("甲子", "戌亥");
        kongWang.put("乙丑", "戌亥");
        kongWang.put("丙寅", "戌亥");
        kongWang.put("丁卯", "戌亥");
        kongWang.put("戊辰", "戌亥");
        kongWang.put("己巳", "戌亥");
        kongWang.put("庚午", "戌亥");
        kongWang.put("辛未", "戌亥");
        kongWang.put("壬申", "戌亥");
        kongWang.put("癸酉", "戌亥");

        //2甲戌旬
        kongWang.put("甲戌", "申酉");
        kongWang.put("乙亥", "申酉");
        kongWang.put("丙子", "申酉");
        kongWang.put("丁丑", "申酉");
        kongWang.put("戊寅", "申酉");
        kongWang.put("己卯", "申酉");
        kongWang.put("庚辰", "申酉");
        kongWang.put("辛巳", "申酉");
        kongWang.put("壬午", "申酉");
        kongWang.put("癸未", "申酉");

        //3甲申旬
        kongWang.put("甲申", "午未");
        kongWang.put("乙酉", "午未");
        kongWang.put("丙戌", "午未");
        kongWang.put("丁亥", "午未");
        kongWang.put("戊子", "午未");
        kongWang.put("己丑", "午未");
        kongWang.put("庚寅", "午未");
        kongWang.put("辛卯", "午未");
        kongWang.put("壬辰", "午未");
        kongWang.put("癸巳", "午未");


        //4甲午旬
        kongWang.put("甲午", "辰巳");
        kongWang.put("乙未", "辰巳");
        kongWang.put("丙申", "辰巳");
        kongWang.put("丁酉", "辰巳");
        kongWang.put("戊戌", "辰巳");
        kongWang.put("己亥", "辰巳");
        kongWang.put("庚子", "辰巳");
        kongWang.put("辛丑", "辰巳");
        kongWang.put("壬寅", "辰巳");
        kongWang.put("癸卯", "辰巳");


        //5甲辰旬
        kongWang.put("甲辰", "寅卯");
        kongWang.put("乙巳", "寅卯");
        kongWang.put("丙午", "寅卯");
        kongWang.put("丁未", "寅卯");
        kongWang.put("戊申", "寅卯");
        kongWang.put("己酉", "寅卯");
        kongWang.put("庚戌", "寅卯");
        kongWang.put("辛亥", "寅卯");
        kongWang.put("壬子", "寅卯");
        kongWang.put("癸丑", "寅卯");

        //6甲寅旬
        kongWang.put("甲寅", "子丑");
        kongWang.put("乙卯", "子丑");
        kongWang.put("丙辰", "子丑");
        kongWang.put("丁巳", "子丑");
        kongWang.put("戊午", "子丑");
        kongWang.put("己未", "子丑");
        kongWang.put("庚申", "子丑");
        kongWang.put("辛酉", "子丑");
        kongWang.put("壬戌", "子丑");
        kongWang.put("癸亥", "子丑");


        //纳音
        naYin.put("甲子", "海中金");
        naYin.put("乙丑", "海中金");
        naYin.put("丙寅", "炉中火");
        naYin.put("丁卯", "炉中火");
        naYin.put("戊辰", "大林木");
        naYin.put("己巳", "大林木");
        naYin.put("庚午", "路旁土");
        naYin.put("辛未", "路帝土");
        naYin.put("壬申", "剑锋金");
        naYin.put("癸酉", "剑锋金");

        naYin.put("甲戌", "山头火");
        naYin.put("乙亥", "山头火");
        naYin.put("丙子", "洞下水");
        naYin.put("丁丑", "洞下水");
        naYin.put("戊寅", "城墙土");
        naYin.put("己卯", "城墙土");
        naYin.put("庚辰", "白腊金");
        naYin.put("辛巳", "白腊金");
        naYin.put("壬午", "杨柳木");
        naYin.put("癸未", "杨柳木");

        naYin.put("甲申", "泉中水");
        naYin.put("乙酉", "泉中水");
        naYin.put("丙戌", "屋上土");
        naYin.put("丁亥", "屋上土");
        naYin.put("戊子", "霹雷火");
        naYin.put("己丑", "霹雷火");
        naYin.put("庚寅", "松柏木");
        naYin.put("辛卯", "松柏木");
        naYin.put("壬辰", "常流水");
        naYin.put("癸巳", "常流水");

        naYin.put("甲午", "沙中金");
        naYin.put("乙未", "沙中金");
        naYin.put("丙申", "山下火");
        naYin.put("丁酉", "山下火");
        naYin.put("戊戌", "平地木");
        naYin.put("己亥", "平地木");
        naYin.put("庚子", "壁上土");
        naYin.put("辛丑", "壁上土");
        naYin.put("壬寅", "金箔金");
        naYin.put("癸卯", "金箔金");

        naYin.put("甲辰", "佛灯火");
        naYin.put("乙巳", "佛灯火");
        naYin.put("丙午", "天河水");
        naYin.put("丁未", "天河水");
        naYin.put("戊申", "大驿土");
        naYin.put("己酉", "大驿土");
        naYin.put("庚戌", "钗钏金");
        naYin.put("辛亥", "钗钏金");
        naYin.put("壬子", "桑松木");
        naYin.put("癸丑", "桑松木");

        naYin.put("甲寅", "大溪水");
        naYin.put("乙卯", "大溪水");
        naYin.put("丙辰", "沙中土");
        naYin.put("丁巳", "沙中土");
        naYin.put("戊午", "天上火");
        naYin.put("己未", "天上火");
        naYin.put("庚申", "石榴木");
        naYin.put("辛酉", "石榴木");
        naYin.put("壬戌", "大海水");
        naYin.put("癸亥", "大海水");


        //喜用
        List<String> muQ = new ArrayList<String>();
        muQ.add("火");
        muQ.add("土");
        xiYong.put("木强",muQ);

        List<String> muR = new ArrayList<String>();
        muR.add("木");
        muR.add("水");
        xiYong.put("木弱",muR);

        List<String> huoQ = new ArrayList<String>();
        huoQ.add("土");
        huoQ.add("金");
        xiYong.put("火强",huoQ);

        List<String> huoR = new ArrayList<String>();
        huoR.add("火");
        huoR.add("木");
        xiYong.put("火弱",huoR);

        List<String> tuQ = new ArrayList<String>();
        tuQ.add("金");
        tuQ.add("水");
        xiYong.put("土强",tuQ);

        List<String> tuR = new ArrayList<String>();
        tuR.add("土");
        tuR.add("火");
        xiYong.put("土弱",tuR);

        List<String> jinQ = new ArrayList<String>();
        jinQ.add("水");
        jinQ.add("木");
        xiYong.put("金强",jinQ);

        List<String> jinR = new ArrayList<String>();
        jinR.add("金");
        jinR.add("土");
        xiYong.put("金弱",jinR);

        List<String> shuiQ = new ArrayList<String>();
        shuiQ.add("木");
        shuiQ.add("火");
        xiYong.put("水强",shuiQ);

        List<String> shuiR = new ArrayList<String>();
        shuiR.add("水");
        shuiR.add("金");
        xiYong.put("水弱",shuiR);

        //喜用的号码
        List<String> numberShui = new ArrayList<String>();
        numberShui.add("1");
        numberShui.add("6");
        xiNumber.put("水",numberShui);

        List<String> numberHuo = new ArrayList<String>();
        numberHuo.add("2");
        numberHuo.add("7");
        xiNumber.put("火",numberHuo);

        List<String> numberMu = new ArrayList<String>();
        numberMu.add("3");
        numberMu.add("8");
        xiNumber.put("木",numberMu);

        List<String> numberJin = new ArrayList<String>();
        numberJin.add("4");
        numberJin.add("9");
        xiNumber.put("金",numberJin);

        List<String> numberTu = new ArrayList<String>();
        numberTu.add("5");
        numberTu.add("0");
        xiNumber.put("土",numberTu);


        //燥湿平衡
        zaoShi.put("辰","水");
        zaoShi.put("丑","水");
        zaoShi.put("未","火");
        zaoShi.put("戌","火");

    }




    public static int generateRelationship(String element1, String element2) {
        // 五行关系的映射关系
        String[][] relationships = {
                //木属性
                {"木", "火", "1"},    //木生火 = 1
                {"木", "土", "2"},    //木克土 = 2
                {"木", "金", "3"},    //木被金克 = 3
                {"木", "水", "4"},    //木被水生 = 4
                {"木", "木", "0"},    //木被木生=  0
                // 火属性
                {"火", "土", "1"},    //火生土 = 1
                {"火", "金", "2"},    //火克金 = 2
                {"火", "水", "3"},    //火被水克 = 3
                {"火", "木", "4"},    //火被木生 = 4
                {"火", "火", "0"},    //火被火生 = 0
                // 土属性的关系
                {"土", "金", "1"},    //土生金 = 1
                {"土", "水", "2"},    //土克水 = 2
                {"土", "木", "3"},    //土被木克 = 3
                {"土", "火", "4"},    //土被火生 = 4
                {"土", "土", "0"},    //土被土生 = 0
                // 金属性的关系
                {"金", "水", "1"},    //金生水 = 1
                {"金", "木", "2"},    //金克木 = 2
                {"金", "火", "3"},    //金被火克 = 3
                {"金", "土", "4"},    //金被土生 = 4
                {"金", "金", "0"},    //金被金生 = 0
                // 水属性的关系
                {"水", "木", "1"},    //水生木 = 1
                {"水", "火", "2"},    //水克火 = 2
                {"水", "土", "3"},    //水被土克 = 3
                {"水", "金", "4"},    //水被金生 = 4
                {"水", "水", "0"},    //水被水生 = 0
        };

        // 查找两个元素之间的关系
        for (String[] relationship : relationships) {
            if (relationship[0].equals(element1) && relationship[1].equals(element2)) {
                int result = Integer.parseInt(relationship[2]);
                if(result == 1 || result == 2 || result == 3) { //减分
                    return -1;
                } else if(result == 4 || result == 0) {    //加减
                    return 1;
                }
            }
        }
        // 如果没有找到对应关系，可以返回一个默认值或抛出异常，这里简单返回 -1
        return -99;
    }



}
