package com.miaxis.gan.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.miaxis.disease.domain.DiseasePart;
import com.miaxis.gan.domain.GanZhi;
import com.miaxis.gan.dto.GanZhiDto;
import com.miaxis.gan.vo.GanZhiKongWangVo;
import com.miaxis.gan.vo.GanZhiNaYinVo;
import com.miaxis.gan.vo.GanZhiRowVo;

import java.util.List;
import java.util.Map;

/**
 * 天干地支Service接口
 *
 * @author miaxis
 * @date 2023-11-16
 */
public interface IGanZhiService extends IService<GanZhi>{
    /**
     * 查询天干地支列表
     *
     * @param ganZhi 天干地支
     * @return 天干地支集合
     */
    List<GanZhi> selectGanZhiList(GanZhi ganZhi);

    List<GanZhiRowVo> selectGanZhiRowVoList(GanZhiDto ganZhiDto);

    List<GanZhiNaYinVo> selectGanZhiNaYinList(GanZhiDto ganZhiDto);

    List<GanZhiKongWangVo> selectGanZhiKongWangList(GanZhiDto ganZhiDto);


    /**
     * 日元的强
     * @param ganZhiDto
     * @return
     */
    Map<String,Object> getRiYuanQr(GanZhiDto ganZhiDto);

    /**
     * 疾病
     * @param ganZhiDto
     * @return
     */
    List<DiseasePart> getJiBin(GanZhiDto ganZhiDto);

    /**
     * 返回喜用数字
     * @param qr 日元强弱MAP
     * @return
     */
    Map<String, Object> getNumberYun(Map<String, Object> qr);

    Map<String,Integer> getGanZhiRowVoCount(GanZhiDto ganZhiDto);


    /**
     * 潮湿平衡
     * @param ganZhiDto
     * @return
     */
    Map<String, Object> getZaoShiCount(GanZhiDto ganZhiDto);
}
