package com.miaxis.gan.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.miaxis.disease.domain.DiseasePart;
import com.miaxis.number.domain.NumberYun;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 天干地支对象 gan_zhi
 *
 * @author miaxis
 * @date 2023-11-16
 */
@Data
public class GanZhiVo {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "姓名")
    private String username;

    @ApiModelProperty(value = "性别")
    private Integer sex;

    @ApiModelProperty(value = "(公历)出生日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date birthDay;

    @ApiModelProperty(value = "(农历)出生日期")
    private String nongDay;


    @ApiModelProperty(value = "日元强弱")
    private Map<String,Object> riYuan;

    @ApiModelProperty(value = "喜用数字")
    private Map<String,Object> numberYunMap;

    @ApiModelProperty(value = "八字五行集合")
    private List<GanZhiRowVo> ganZhiRowVoList;

    @ApiModelProperty(value = "八字五行个数集合")
    private Map<String,Integer> fiveCountMap;

    @ApiModelProperty(value = "八字燥湿集合")
    private Map<String,Object> zaoShiMap;

    @ApiModelProperty(value = "八字纳音")
    private List<GanZhiNaYinVo> ganZhiNaYinVoList;

    @ApiModelProperty(value = "八字空亡")
    private List<GanZhiKongWangVo> ganZhiKongWangVoList;

    @ApiModelProperty(value = "疾病集合")
    private List<DiseasePart> diseasePartList;

}
